rm(list=ls())
#Lecture 2: Clustering and distance

lezards<-read.csv(file.choose())
View(lezards)
lezards2<-read.csv(file.choose(), row.names = 1)
View(lezards2)

summary(lezards2)
cov(lezards2)
cor(lezards2)
#Plotting
#I am loading a dataset about paper strength. 
#There are three variables: density, forceA and force

#I will plot different featurs of the paper
track<-read.csv(file.choose())
View(track)
plot(track)
cor(track)
cor(track[,3:9])
plot(track$m100,track$m200)
plot(track$m100,track$m200, main = "Track Races", 
     xlab="100 Metres", ylab="200 Metres")
boxplot(track)
boxplot(track$m100)

#If I want to create a histogram of the data
hist(track$m100)
hist(track$marathon)
#Load 
help(plot)

# Simple Pie Chart from "https://www.statmethods.net/graphs/pie.html"
#However, pie charts are the best for data analysis
slices <- c(10, 12,4, 16, 8)
lbls <- c("US", "UK", "Australia", "Germany", "France")
pie(slices, labels = lbls, main="Pie Chart of Countries")

#plotting lizards
plot(lezards2)
plot(lezards2$mass,lezards2$SVL)
boxplot(lezards2)

singlematrix<-matrix(c(0,9,3,6,11,9,0,7,5,10,3,7,0,9,2,6,5,9,0,8,11,10,2,8,0),5,5)
singlematrix
as.dist and dist
singledistance <- as.dist(singlematrix)
fitsingle <- hclust(singledistance, method="single")
plot(fitsingle)

singleave<-hclust(singled,method="average")
plot(singleave)

singlecomp<-hclust(singled,method="complete")
plot(singlecomp)

singleward<-hclust(singled,method="ward.D")
plot(singleward)

#plot on 1 chart
par(mfrow=c(2,2)) 
plot(fitsingle)
plot(singleave)
plot(singlecomp)
plot(singleward)
par(mfrow=c(1,1))

----------------------------------
#importing data
X<-read.table(file.choose())
Y<-read.csv(file.choose())
help(read.table)
help(scan)
#In Class problem 1
#Read a triangle matrix

## Reading a triangular matrix from a file

langdist<-read.csv(file.choose()) ##Read langdistanceSQ 
View(langdist)
#dissimilar. Bigger the number the farther away there are
mla <- 10 - langdist
10-mla
langdist
langdist
#Example 12.4 Clustering with single linkage
Lang <- c("E","N","Da","Du","G","Fr","Sp","I","P","H","Fi")
colnames(mla) <- Lang
rownames(mla) <- Lang

mla


#as.dist coerces a matrix to the dist() format
#The hclust() function takes dist()
#dist() calculates the actual Euclidean distance 
#while as.dist transforms a distance type of matrix to distance (takes a square matrix) 
dl2 <- as.dist(mla)
dl2

elect<-read.csv(file.choose())
elect
elect2<-elect[,-1]
elect2
row.names(elect2)<-elect2[,9]
elect2
elect3<-elect2[,-9]
elect3
distelec<-dist(elect3)
fitelec<-hclust(distelec,method="single")
plot(fitelec)
#hclust
fit <- hclust(dl2, method="single")
plot(fit)

fitcomp<-hclust(dl2,method="complete")
plot(fitcomp)

fitave<-hclust(dl2,method="average")
plot(fitave)

fitward<-hclust(dl2,method="ward.D")
plot(fitward)

#What values go into the number of clusters
a<-cutree(fitward,2)
a
b<-cutree(fitward,3)
b
table(a,b)

library(cluster)
#tell it the number of clusters and the distance
#The output shows the similarity of points in cluster. Ranges from -1 to 1
#The closer to 1 the more likely it is in the right cluster
plot(silhouette(a,dl2))
#the bigger the number the closer
plot(silhouette(b,dl2))

#plot on 1 chart
par(mfrow=c(2,2)) 
plot(fit)
plot(fitcomp)
plot(fitave)
plot(fitward)


#-----------------------------------------------------
#Pratique

Util <- read.csv(file.choose())    ## Read table electricity
View(Util)
head(Util)
Y <- as.matrix(Util[,2:8])
pairs(Y)
Ylabel<-c("fixcharge","return","energycost","load","peak","sales","nuclear","fuelcost")
colnames(Y)<-Ylabel
rownames(Y)<-Util[,10]
View(Y)
corya<-cor(Y)
corya
disutil<-dist(Y)
disutil

fitY <- hclust(disutil, method="single")
fitYcomp<-hclust(disutil,method="complete")
fitYave<-hclust(disutil,method="average")
fitYward<-hclust(disutil,method="ward.D")

par(mfrow=c(2,2)) 
plot(fitY)
plot(fitYcomp)
plot(fitYave)
plot(fitYward)

#-------------------------------------------
#In Class example 2



#------------------------------------------------------------
#kmeans example

fit <- kmeans(elect3, 5, iter.max=40, algorithm="MacQueen")
fit
fit$cluster
fit$centers
fit$size


clust<-fit$cluster
clust
par(mfrow=c(1,1)) 
plot(Y[,1],Y[,2],col=fit$cluster, pch=19, main="K-means Clustering of Utility Data", xlab="Fixcharge", ylab="return")

## With standardized observations use 
Ys <- scale(Util[,1:8], center=TRUE, scale=apply(Util[,1:8],2,sd))
fits<-fit <- kmeans(Ys, 5, iter.max=40, algorithm="MacQueen")
fits
plot(Ys[,1],Ys[,2],col=fits$cluster)

#practice
track<-read.csv(file.choose())#read track data
View(track)
trackmat<-as.matrix(track[,3:9])
rownames(trackmat) <- track[,2]
View(trackmat)

distrack<-dist(t(trackmat))
distrack
#b
par(mfrow=c(2,1)) 

fittrack <- hclust(distrack, method="single")
fittrackcomp<-hclust(distrack,method="complete")

plot(fittrack)
plot(fittrackcomp)

#c
ktrack5 <- kmeans(trackmat, 5, iter.max=40, algorithm="MacQueen")
ktrack5
par(mfrow=c(1,1))
plot(trackmat[,1],trackmat[,2], col=ktrack5$cluster)
cbind(ktrack5$cluster,track[,1])

ktrack4 <- kmeans(trackmat, 4, iter.max=40, algorithm="MacQueen")
ktrack4

ktrack3 <- kmeans(trackmat, 3, iter.max=40, algorithm="MacQueen")
ktrack3

trackgroup<-cbind(track[,1],ktrack5$cluster,ktrack4$cluster,ktrack3$cluster)
trackgroup

