#Lecture 5 Regression

rm(list=ls())

#this command shows you datasets that are already in R
data()
#to load the dataset 
data("VADeaths")
head(VADeaths)
summary(VADeaths)
#to learn more about the data 
?VADeaths

data("mtcars")
?mtcars
head(mtcars)
plot(mtcars$mpg,mtcars$hp)
plot(mtcars$mpg,mtcars$hp, col=mtcars$vs+1)
plot(mtcars$mpg,mtcars$hp, pch=5)
hist(mtcars$mpg)
boxplot(mtcars$mpg)
cor(mtcars)
distcars<-dist(mtcars)
fit2 <- hclust(distcars, method="single")
plot(fit2)
fit3 <- hclust(distcars, method="ward.D")
plot(fit3)
kmeans(mtcars,)
kmeanscar <- kmeans(mtcars,3, iter.max=40, algorithm="MacQueen")
summary(kmeanscar)
kmeanscar
#--------------------------------------------------------
#regression
a<-matrix(c(0,1,2,3,4,1,4,3,8,9),5,2,byrow=F)
a 
plot(a, col="red",pch=19)
y<-a[,2]
y
x<-a[,1]
reg1<-lm(y~x)
summary(reg1)

plot(a)
abline(a=1, b=2, col="red")

#Bigger example with mtcars

head(mtcars)
summary(mtcars)
?mtcars
#attaching allows us to call the variable names in the equation
attach(mtcars)
regcars<-lm(mpg~cyl+wt+qsec)
summary(regcars)

29.42/8.1912

#regression with electricity
elect <- read.csv(file.choose())    ## Read table 12.4
head(elect)
elect2<-elect[,-1]
names(elect2)<-c("fixcharge","return",
                "energycost","load","peak",
                "sales","nuclear","fuelcost")
head(elect2)
row.names(elect2)<-elect2[,9]
elect3<-elect2[,-9]
head(elect3)
#regression
#Regress fuelcosts, energy cost and 
#load on sales
#(sales is the dependent variable). 

reg_elect<-lm(elect3$sales~elect3$fuelcost
              +elect3$energycost
              +elect3$load) 

#print results
summary(reg_elect)

#add binary variable
summary(mtcars)
regcars2<-lm(mpg~cyl+wt+vs+am)
summary(regcars2)

#practice
head

#add quadratic term
qsecsq<-qsec^2
mtcars2<-cbind(mtcars,qsecsq)
head(mtcars2)
attach(mtcars2)
regcars3<-lm(mpg~cyl+wt+qsec+am+qsecsq)
summary(regcars3)
#Load pollution data
pollution<-read.csv(file.choose())
#first step of data Analysis is cleaning the data

airqualityremove<-na.omit(airquality)
summary(airqualityremove)
data(airquality)
head(airquality)
summary(airquality)
hist(airquality$Ozone)
logozone<-log(airquality$Ozone)
hist(logozone)
airquality$Ozone
plot(airquality$Temp,airquality$Ozone)
plot(airquality$Temp,airquality$Ozone, col="blue", pch=19)
plot(airquality$Temp,airquality$Ozone, col="blue", pch=19,
     main="Plot of Ozone vs Temperature",
     xlab="Temperature (F)",
     ylab="Ozone (PPB)")
Ozone
attach(airquality)
Ozone
boxplot(Ozone)

regozone<-lm(Ozone~Temp+Solar.R+ Wind+Month+Day )
summary(regozone)

plot(ChickWeight$Time,ChickWeight$weight,col=ChickWeight$Diet, pch=19)

regchick<-lm(ChickWeight$weight~ChickWeight$Time+ChickWeight$Diet )
summary(regchick)
