rm(list=ls())

#Lecture6 Logit
opm<-read.csv(file.choose(), header=T)
head(opm)
attach(opm)
regmale<-lm(promo~maleca)
summary(regmale)

table(promo, maleca)
probfemale<-654/(3164+654)
probfemale
probmale<-489/(2803+489)
probmale

probmale-probfemale

regmaleresid<-regmale$residuals
regmaleresid
plot(regmale)

#with larger model predicted value of promotion is less than 0
#this makes no sense
regpromo<-lm(promo~maleca+vet+age+yos+grade+edyrs)
summary(regpromo)
fitvalue<-regpromo$fitted.values
head(fitvalue)
summary(fitvalue)

#Logit
regmale2<-glm(promo~maleca)
summary(regmale2)
summary(regmale)

logitmale<-glm(promo~maleca, family="binomial")
summary(logitmale)

logitpromo<-glm(promo~maleca+vet+age+yos+grade+edyrs, family="binomial")
summary(logitpromo)
confint(logitpromo)
fittedpromo<-fitted(logitpromo)
head(fittedpromo)
newpromodata2<-data.frame(maleca=1, vet=1,age=46, yos=mean(yos),
                          grade=mean(grade), edyrs=mean(edyrs))
predict(logitpromo, newpromodata2, type="response")

#odds ratio
exp(coef(logitpromo))
exp(cbind(OR = coef(logitpromo), confint(logitpromo)))

#In-class R code
rm(list=ls())
opm<-read.csv(file.choose(), header=T)
View(opm)
summary(opm)
attach(opm)
str(opm)
opm$maleca[male=="Male"]<-1
opm$maleca[male=="Female"]<-0
View(opm)
opm$maleca2<-as.factor(male)
View(opm)
str(opm)
summary(opm)
#ways to omit data
opmomit<-na.omit(opm)
opmomit2<-opm[complete.cases(opm),]


#which rows are missing data
opm[!complete.cases(opm),]
opmomit[!complete.cases(opmomit),]

attach(opmomit)
View(opmomit)


#----------

reg1<-lm(salary~maleca+vet+age+yos+grade+edyrs)
summary(reg1)
plot(reg1)


reg3<-lm(salary~yos+yossq)
summary(reg3)

reg4<-lm(salary~maleca+age+yos+yossq)
summary(reg4)

#paraboloa opens downward since the yossq term is negative
ggplot(data=opmomit, aes(x=yos, y=salary))+
  geom_point()+
  stat_smooth(method="lm", se=T, col="red")
expmax<- 1702.22/(2*23.92)
expmax

expmaxsal<-52899.86+1752.797*expmax-24.136*(expmax)^2
expmaxsal

#------in class problem 2
library(psych)
describe(promo)
describe(maleca)
summary(promo)

regmale<-lm(promo~maleca)
summary(regmale)

table(promo, maleca)
probfemale<-654/(3164+654)
probfemale
probmale<-489/(2803+489)
probmale

probmale-probfemale

regmaleresid<-regmale$residuals

plot(regmale)
#--------
salmon<-read.csv(file.choose())
View(salmon)
str(salmon)
attach(salmon)
salmon$pop<-as.factor(pop)
#note that 1 is Alaskan and 2 is Canadian
salmon$gender<-as.factor(gender)
plot(fresh, marine,col=gender, pch=pop)
head(salmon)
str(salmon)
attach(salmon)
head(salmon)

logitsalmon<-glm(as.factor(pop)~gender+fresh
                 +marine,
                 family="binomial")
summary(logitsalmon)
exp(cbind(OR = coef(logitsalmon), 
          confint(logitsalmon)))

logitsalmon2<-glm(pop~gender+fresh+marine, family="binomial")
summary(logitsalmon2)

predsalmon<-data.frame(gender=2, 
                       fresh=130, marine=435)#note that because these are factors we have to use "2"
predsalmon2<-data.frame(gender=1, 
                        fresh=130, marine=435)
predict(logitsalmon, predsalmon, 
        type="response")
predict(logitsalmon, predsalmon2, 
        type="response")

ggplot()+
  geom_point(data=salmon, aes(x=fresh, y=marine, color=gender, shape=pop), size=5)+
  geom_point(aes(x=130, y=435), color="blue", size=4)+
  labs(title="Freshwater vs Marine water Salmon")



#prediction 2
predict(logitsalmon, data.frame(gender=1, fresh=180, marine=300), type="response")
predict(logitsalmon, data.frame(gender=1, fresh=80, marine=450), type="response")

#odds ratio
exp(coef(logitsalmon))
exp(cbind(OR = coef(logitsalmon), confint(logitsalmon)))


#extra practice code
Salmon2<-Salmon
Salmon2[,1]<-Salmon[,1]-1
View(Salmon2)
mylogit <- glm(Place ~ Gender + Fresh + Marine, data = Salmon2, family = "binomial")
summary(mylogit)



salpred<-predict.glm(mylogit, newdata=Salmon2)
View(salpred)
#if values are negative they are Alaska, if positive they are classifid as Canadian. 

#Logit

#-extra
#confusion matrix with Logit
View(fittedpromo)

table(fittedpromo>.5, promo)
GPA.class <- predict(GPA.disc, method="plug-in")$class
table(Admission, GPA.class)
apergpa<-(1+4+2)/85
apergpa

